<template>
  <v-container>
    <v-row justify="space-between">
      <v-col :cols="showRepeats ? 4 : 5">
        <sync-field
          v-if="state"
          ref="source"
          v-model="state.point[0]"
          :signature="signature"
          :type="sourceFieldType"
          @input="updateSyncPoint"
        />
        <!-- The disabled field -->
        <!-- Used because v-model has to resolve to an actual property -->
        <!-- TODO: move away from v-model, and just use @input -->
        <sync-field
          v-else
          :value="null"
          :signature="signature"
          :type="sourceFieldType"
        />
      </v-col>
      <v-col :cols="showRepeats ? 4 : 5">
        <sync-field
          v-if="state"
          ref="target"
          v-model="state.point[1]"
          :signature="signature"
          :type="targetFieldType"
          @input="updateSyncPoint"
        />
        <!-- The disabled field -->
        <!-- Used because v-model has to resolve to an actual property -->
        <sync-field
          v-else
          ref="target"
          :value="null"
          :signature="signature"
          :type="targetFieldType"
        />
      </v-col>
      <v-col v-if="showRepeats" cols="2">
        <sync-field
          v-if="state"
          ref="target"
          v-model="state.point[2]"
          :signature="signature"
          type="repeat"
          @input="updateSyncPoint"
        />
        <!-- The disabled field -->
        <!-- Used because v-model has to resolve to an actual property -->
        <sync-field
          v-else
          ref="target"
          :value="null"
          :signature="signature"
          type="repeat"
        />
      </v-col>
      <v-col cols="2">
        <dez-fab
          :key="actions.selectCount"
          class="ma-5"
          color="warning"
          icon="mdi-delete"
          :tooltip="$t('sync-bar.tooltip.delete')"
          :disabled="!state || !state.canDelete"
          @click="() => actions.deleteSelected(true, true)"
        />
        <dez-fab
          class="ma-5"
          color="warning"
          icon="mdi-unfold-more-vertical"
          :tooltip="$t('sync-bar.tooltip.translate')"
          @click="() => $emit('toggle-translator')"
        />
      </v-col>
    </v-row>
    <v-row>
      <v-alert v-if="message" type="warning">
        {{ message }}
      </v-alert>
    </v-row>
    <v-row>
      <v-col>
        <sync-repeats
          :second-unit="secondUnit"
          :actions="actions"
          @reset-sync="(repeat) => $emit('reset-sync', repeat)"
        />
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">
import {
  Vue, Component, Prop, Ref, Watch,
} from 'vue-property-decorator';
import type {
  LabelId, Second, Signature, SyncPoint, Unit,
} from '@/data';
import type SynchronizationActions from '@/synchronization-logic/SynchronizationActions';
import DezFab from '@/vuejs/components/utils/DezFab.vue';
import SyncField, { SyncFieldType } from './SyncField.vue';
import SyncRepeats from './SyncRepeats.vue';

export interface State {
  id: LabelId,
  point: SyncPoint;
  canDelete: boolean;
}

@Component({
  components: {
    SyncField,
    DezFab,
    SyncRepeats,
  },
})
export default class SyncBar extends Vue {
  @Prop({ required: true })
  actions!: SynchronizationActions;

  @Prop({ required: true })
  signature!: Signature;

  @Prop({ validator: (v: SyncFieldType) => Object.values(SyncFieldType).includes(v) })
  sourceFieldType!: SyncFieldType;

  @Prop({ validator: (v: SyncFieldType) => Object.values(SyncFieldType).includes(v) })
  targetFieldType!: SyncFieldType;

  @Prop({ required: true })
  secondUnit!: Unit<Second>;

  state: State | null = null;

  message = '';

  get showRepeats(): boolean {
    return this.$store.state.debugMode;
  }

  @Watch('actions.selectCount')
  @Watch('actions.editCount')
  updatedSelected() {
    const label = this.actions.getSelected();

    // If a label is selected
    if (label) {
      // Create a copy of the label sync point
      const point = [...label.point] as SyncPoint;
      const { id } = label;
      // Forbid deleting the first and last sync point
      const canDelete = !!(this.actions.getPrev(id) && this.actions.getNext(id));
      // Init the state
      this.state = { point, id, canDelete };
    } else {
      this.state = null;
    }
    this.message = '';
  }

  updateSyncPoint() {
    if (!this.state) return;

    try {
      // Try to set the point
      this.actions.setSyncPoint(this.state.id, this.state.point);
      this.message = '';
      // Make sure everything is still synced
      this.updatedSelected();
    } catch (e) {
      this.message = (e as Error).message;
    }
  }

  @Ref()
  target!: SyncField;

  public async focus() {
    // Wait for target field to be loaded
    await Vue.nextTick();
    await Vue.nextTick();
    // Focus target field
    if (this.state) this.target?.focus();
  }
}
</script>
